﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Controls.Charts;
using System.Windows;
using System.Windows.Input;

namespace Geoservice.Kpi.WPF.TestUI
{
    public class CustomXamDataChart : XamDataChart
    {
        public CustomXamDataChart()
        {
            this.MouseUp += new MouseButtonEventHandler(OnMouseUp);

        }
        public DateTime? XDate
        {
            get { return (DateTime)this.GetValue(XDateProperty); }
            set { this.SetValue(XDateProperty, value); }
        }

        public static readonly DependencyProperty XDateProperty = DependencyProperty.Register(
            "XDate", typeof(DateTime?), typeof(CustomXamDataChart), new PropertyMetadata(false));


        private void OnMouseUp(object sender, MouseEventArgs e)
        {
            if (Mouse.Captured == this)
            {
                var serie = this.Series.FirstOrDefault();
                if (serie == null)
                {
                    return;
                }

                // Get the current mouse position relative to the volume control
                Point currentLocation = Mouse.GetPosition(serie);

                //we are only accounting for CategoryDateTimeXAxis in the following logic.  
                if (!serie.Chart.Axes.OfType<CategoryDateTimeXAxis>().Any())
                {
                    return;
                }

                var x = serie.Chart.Axes.OfType<CategoryDateTimeXAxis>().First();
                var y = serie.Chart.Axes.OfType<NumericYAxis>().First();

                var viewport = new Rect(0, 0, x.ActualWidth, y.ActualHeight);
                var window = serie.Chart.WindowRect;


                var unscaledX = x.GetUnscaledValue(currentLocation.X, window, viewport);

                this.XDate = new DateTime((long)unscaledX);
            }
        }
    }
}
